/*
------------------------------------------------------------
Copyright 2003-201x Haute �cole ARC Ing�ni�rie, Switzerland. 
All rights reserved.
------------------------------------------------------------
File name : 	mGyroAccelMag.h	
Author and date :	Monnerat Serge 06.06.20xx

Goal : exploitation du gyroscope/acc�l�rom�tre/magn�toscope INVENSENSE MPU-9250

-----------------------------------------------------------------------------
History:
-----------------------------------------------------------------------------

$History: $

-----------------------------------------------------------------------------
*/


#ifndef  __MGYROACCELMAG__
#define __MGYROACCELMAG__

#include"def.h"

typedef enum{
	kSELF_TEST_X_GYRO 	=0x00,
	kSELF_TEST_Y_GYRO 	=0x01,
	kSELF_TEST_Z_GYRO	=0x02,
	kMAG_XOUT_L			=0x03,
	kMAG_XOUT_H			=0x04,
	kMAG_YOUT_L			=0x05,
	kMAG_YOUT_H			=0x06,
	kMAG_ZOUT_L			=0x07,
	kMAG_ZOUT_H			=0x08,
	kCNTL1				=0x0A,
	kCTNL2				=0x0B,
	kSELF_TEST_X_ACCEL	=0x0D,
	kSELF_TEST_Y_ACCEL	=0x0E,
	kSELF_TEST_Z_ACCEL	=0x0F,
	kXG_OFFSET_H		=0x13,
	kXG_OFFSET_L		=0x14,
	kYG_OFFSET_H		=0x15,
	kYG_OFFSET_L		=0x16,
	kZG_OFFSET_H		=0x17,
	kZG_OFFSET_L		=0x18,
	kSMPLRT_DIV			=0x19,
	kCONFIG				=0x1A,
	kGYRO_CONFIG		=0x1B,
	kACCEL_CONFIG		=0x1C,
	kACCEL_CONFIG2		=0x1D,
	kLP_ACCEL_ODR		=0x1E,
	kWOM_THR			=0x1F,
	kFIFO_EN			=0x23,
	kI2C_MST_CTRL		=0x24,
	kI2C_SLV0_ADDR		=0x25,
	kI2C_SLV0_REG		=0x26,
	kI2C_SLV0_CTRL		=0x27,
	kI2C_SLV1_ADDR		=0x28,
	kI2C_SLV1_REG		=0x29,
	kI2C_SLV1_CTRL		=0x2A,
	kI2C_SLV2_ADDR		=0x2B,
	kI2C_SLV2_REG		=0x2C,
	kI2C_SLV2_CTRL		=0x2D,
	kI2C_SLV3_ADDR		=0x2E,
	kI2C_SLV3_REG		=0x2F,
	kI2C_SLV3_CTRL		=0x30,
	kI2C_SLV4_ADDR		=0x31,
	kI2C_SLV4_REG		=0x32,
	kI2C_SLV4_DO		=0x33,
	kI2C_SLV4_CTRL		=0x34,
	kI2C_SLV4_DI		=0x35,
	kI2C_MST_STATUS 	=0x36,
	kINT_PIN_CFG 		=0x37,
	kINT_ENABLE			=0x38,
	kINT_STATUS			=0x3A,
	kACCEL_XOUT_H		=0x3B,
	kACCEL_XOUT_L		=0x3C,
	kACCEL_YOUT_H		=0x3D,
	kACCEL_YOUT_L		=0x3E,
	kACCEL_ZOUT_H		=0x3F,
	kACCEL_ZOUT_L		=0x40,
	kTEMP_OUT_H			=0x41,
	kTEMP_OUT_L			=0x42,
	kGYRO_XOUT_H		=0x43,
	kGYRO_XOUT_L		=0x44,
	kGYRO_YOUT_H		=0x45,
	kGYRO_YOUT_L		=0x46,
	kGYRO_ZOUT_H		=0x47,
	kGYRO_ZOUT_L		=0X48,
	kEXT_SENS_DATA_00	=0x49,
	kEXT_SENS_DATA_01	=0x4A,
	kEXT_SENS_DATA_02	=0x4B,
	kEXT_SENS_DATA_03	=0x4C,
	kEXT_SENS_DATA_04	=0x4D,
	kEXT_SENS_DATA_05	=0x4E,
	kEXT_SENS_DATA_06	=0x4F,
	kEXT_SENS_DATA_07	=0x50,
	kEXT_SENS_DATA_08	=0x51,
	kEXT_SENS_DATA_09	=0x52,
	kEXT_SENS_DATA_10	=0x53,
	kEXT_SENS_DATA_11	=0x54,
	kEXT_SENS_DATA_12	=0x55,
	kEXT_SENS_DATA_13	=0x56,
	kEXT_SENS_DATA_14	=0x57,
	kEXT_SENS_DATA_15	=0x58,
	kEXT_SENS_DATA_16	=0x59,
	kEXT_SENS_DATA_17	=0x5A,
	kEXT_SENS_DATA_18	=0x5B,
	kEXT_SENS_DATA_19	=0x5C,
	kEXT_SENS_DATA_20	=0x5D,
	kEXT_SENS_DATA_21	=0x5E,
	kEXT_SENS_DATA_22	=0x5F,
	kEXT_SENS_DATA_23	=0x60,
	kI2C_SLV0_DO		=0x63,
	kI2C_SLV1_DO		=0x64,
	kI2C_SLV2_DO		=0x65,
	kI2C_SLV3_DO		=0x66,
	kI2C_MST_DELAY_CTR	=0x67,
	kSIGNAL_PATH_RESET	=0x68,
	kMOT_DETECT_CTRL	=0x69,
	kUSER_CTRL			=0x6A,
	kPWR_MGMT_1			=0x6B,
	kPWR_MGMT_2			=0x6C,
	kFIFO_COUNTH		=0x72,
	kFIFO_COUNTIL		=0x73,
	kFIFO_R_W			=0x74,
	kWHO_AM_I_G			=0x75,
	kXA_OFFSET_H		=0x77,
	kXA_OFFSET_L		=0x78,
	kYA_OFFSET_H		=0x7A,
	kYA_OFFSET_L		=0x7B,
	kZA_OFFSET_H		=0x7D,
	kZA_OFFSET_L		=0x7E
}GyroAccelEnum;

typedef enum{
	kWIA				=0x00,
	kINFO				=0x01,
	kST1				=0x02,
	kHXL				=0x03,
	kHXH				=0x04,
	kHYL				=0x05,
	kHYH				=0x06,
	kHZL				=0x07,
	kHZH				=0x08,
	kST2				=0x09,
	kCTNL				=0x0A,
	kRSV				=0x0B,
	kASTC				=0x0C,
	kTS1				=0x0D,
	kTS2				=0x0E,
	kI2CDIS				=0x0F,
	ASAX				=0x10,
	ASAY				=0x11,
	ASAZ				=0x12
}MagEnum;


//-----------------------------------------------------------------------------
// Module configuration
//-----------------------------------------------------------------------------
void mGyro_Setup(void);

//-----------------------------------------------------------------------------
// Open module
//-----------------------------------------------------------------------------
void mGyro_Open(void);

//-----------------------------------------------------------------------------
// Close module
//-----------------------------------------------------------------------------
void mGyro_Close(void);

//-----------------------------------------------------------------------------
// Lecture de X, Y et Z
//-----------------------------------------------------------------------------
void mGyro_ReadGyroValues(Int16 *aX, Int16 *aY, Int16 *aZ);
void mGyro_ReadAccelValues(Int16 *aX, Int16 *aY, Int16 *aZ);
void mGyro_ReadMagValues(Int16 *aX, Int16 *aY, Int16 *aZ);
void mGyro_ReadTempValues(Int16 *temp);



#endif
